import { ApolloClient, ApolloQueryResult, WatchQueryOptions, MutationOptions, SubscriptionOptions } from 'apollo-client';
import { Observable } from 'rxjs/Observable';
import { FragmentDefinitionNode } from 'graphql';
import { ApolloQueryObservable } from './ApolloQueryObservable';
export interface DeprecatedWatchQueryOptions extends WatchQueryOptions {
    fragments?: FragmentDefinitionNode[];
}
export declare class Angular2Apollo {
    private client;
    constructor(client: ApolloClient);
    watchQuery<T>(options: DeprecatedWatchQueryOptions): ApolloQueryObservable<ApolloQueryResult<T>>;
    query<T>(options: DeprecatedWatchQueryOptions): Observable<ApolloQueryResult<T>>;
    mutate<T>(options: MutationOptions): Observable<ApolloQueryResult<T>>;
    subscribe(options: SubscriptionOptions): Observable<any>;
    getClient(): ApolloClient;
}
