import { ModuleWithProviders, Provider } from '@angular/core';
import { ApolloClient } from 'apollo-client';
import { Angular2Apollo } from './Angular2Apollo';
import { SelectPipe } from './SelectPipe';
export declare const APOLLO_DIRECTIVES: typeof SelectPipe[];
export declare const APOLLO_PROVIDERS: Provider[];
export declare type ClientWrapper = () => ApolloClient;
export declare function provideAngular2Apollo(): Provider;
export declare function createAngular2Apollo(client: ApolloClient): Angular2Apollo;
export declare function getApolloClient(clientFn: ClientWrapper): ApolloClient;
export declare function defaultApolloClient(clientFn: ClientWrapper): Provider[];
export declare class ApolloModule {
    static withClient(clientFn: ClientWrapper): ModuleWithProviders;
}
